
accounts <- function(agents)
{
  subf.acc <- function(x) {
    xcou <- attr(x, "counts")
    if(!length(xcou)) xcou <- c(nbuyers=0, nsellers=0)
    c(cash=sum(x$cash), shares=sum(x$shares), xcou)
  }

  if(inherits(agents, "marketAgent")) {
    subf.acc(agents)
  } else if(inherits(agents, "marketAgentList")) {
    answer <- subf.acc(agents[[1L]])
    for(i in seq_len(length(agents) - 1L) + 1L) {
      answer <- answer + subf.acc(agents[[i]])
    }
    answer
  } else {
    stop("expecting an agent object for 'agents'")
  }
}
