
backoffice.marketAgent <- function(agents, auctionValue, traders, ...)
{
  if(is.na(price <- auctionValue["price"]) || is.na(auctionValue["buyall"]) ||
     is.na(auctionValue["sellall"])) {
    return(agents)
  }

  buyingAll <- agents$buyAt[traders] >= auctionValue["buyall"]
  sellingAll <- agents$sellAt[traders] <= auctionValue["sellall"]

  # should be smarter about epsilon that hard-coded to 1e-6
  buyingpp <- which(abs(agents$buyAt[traders] - auctionValue["buypartprice"]) < 1e-6)
  buyingfrac <- auctionValue["buyfraction"]

  sellingpp <- which(abs(agents$sellAt[traders] - auctionValue["sellpartprice"]) < 1e-6)
  sellingfrac <- auctionValue["sellfraction"]
  tcash <- agents$cash[traders]
  tshares <- agents$shares[traders]

  cashTotal <- sum(tcash)
  sharesTotal <- sum(tshares)


  if(any(buyingAll, na.rm=TRUE)) {
    bsh <- floor(tcash[buyingAll] / price)
    tshares[buyingAll] <- tshares[buyingAll] + bsh
    tcash[buyingAll] <- tcash[buyingAll] - bsh * price
  }
  if(length(buyingpp)) {
    bshpp <- floor(tcash[buyingpp] / price * buyingfrac)
    tshares[buyingpp] <- tshares[buyingpp] + bshpp
    tcash[buyingpp] <- tcash[buyingpp] - bshpp * price
  }
  if(any(sellingAll, na.rm=TRUE)) {
    tcash[sellingAll] <- tcash[sellingAll] + tshares[sellingAll] * price
    tshares[sellingAll] <- 0
  }
  if(length(sellingpp)) {
    ssh <- round(tshares[sellingpp] * sellingfrac)
    tcash[sellingpp] <- tcash[sellingpp] + ssh * price
    tshares[sellingpp] <- tshares[sellingpp] - ssh
  }
  if(!isTRUE(all.equal(c(cashTotal, sharesTotal), c(sum(tcash), sum(tshares))))) {

  }
  if(!isTRUE(all.equal(c(cashTotal, sharesTotal), c(sum(tcash), sum(tshares))))) {
    warning("difference in cash of ", sum(tcash) - cashTotal, " and in shares of ",
            sum(tshares) - sharesTotal)
  }
  agents$cash[traders] <- tcash
  agents$shares[traders] <- tshares
  attr(agents, "counts") <- c(nbuyers=sum(buyingAll), nsellers=sum(sellingAll))
  agents
}
