
doRun <- function(agents, newsFun=function(...) 0,
                  marketCash=function(...) 0,
                  times=getmaOption("runTimes"), saveAgents=FALSE)
{
  auctionTest <- auction(agents)
  accountsTest <- accounts(agents)
  history <- array(NA_real_, c(times, length(auctionTest)),
                   list(NULL, names(auctionTest)))
  ledger <- array(NA_real_, c(times, length(accountsTest)),
                   list(NULL, names(accountsTest)))
  news <- rep(NA_real_, times)
  if(saveAgents) agentList <- vector("list", times)
  newsFun <- match.fun(newsFun)
  for(i in seq_len(times)) {
    traders <- findTraders(agents)
    history[i,] <- thisAuction <- auction(selectTraders(agents, traders),
                                          marketOrderCash=marketCash(history[seq_len(i-1L),]),
                                          plotVols=getmaOption("showAuctionPlot"))
    currentAgents <- agents
    agents <- backoffice(agents, thisAuction, traders=traders)
    ledger[i, ] <- accounts(agents)
    # avoid bogus trades
    if(testTrade(i, ledger, thisAuction)) {
      history[i, "price"] <- history[i - 1L, "price"]
      history[i, "volume"] <- 0
      agents <- currentAgents
      ledger[i, c("nbuyers", "nsellers")] <- 0
    } else if(anyNA(thisAuction[c("price", "buyall", "sellall")])) {
      history[i, "price"] <- history[i - 1L, "price"]
      history[i, "volume"] <- 0
      ledger[i, c("nbuyers", "nsellers")] <- 0
    }
    iseq <- 1:i
    iHistory <- history[iseq, , drop=FALSE]
    news[i] <- newsFun(iHistory)
    agents <- readNews(agents, news[iseq], iHistory)
    # print(summary(agents))
    if(saveAgents) agentList[[i]] <- agents
  }
  ans <- list(history=history, news=news, ledger=ledger,
              options=getmaOption(NULL), call=match.call())
  class(ans) <- "agentRun"
  ans
}
