
makeAgents <- function(style, n=getmaOption("numberOfAgents"),
                       cashFun=function(n) runif(n, 1000, 1e5),
                       sharesFun=function(n) runif(n, 100, 1e4),
                       buyFun=function(n) runif(n, 88, 92),
                       spreadFun=function(n) runif(n, .5, .8))
{
  randomSeed <- .Random.seed
  cash <- cashFun(n)
  shares <- round(sharesFun(n))
  switch(style,
         a={
           buyAt <- buyFun(n)
           sellAt <- buyAt + spreadFun(n)
           specClass <- "agent_a"
         },
         b={
           buyAt <- buyFun(n)
           sellAt <- buyAt + spreadFun(n)
           specClass <- "agent_b"
         })
  ans <- list(cash=cash, shares=shares, buyAt=buyAt, sellAt=sellAt,
              randomSeed=randomSeed, call=match.call())
  class(ans) <- c(specClass, "marketAgent")
  ans
}
